当前位置: 首页>>代码示例>>Python>>正文


Python FemMeshTools.get_vertexes_by_element方法代码示例

本文整理汇总了Python中FemMeshTools.get_vertexes_by_element方法的典型用法代码示例。如果您正苦于以下问题:Python FemMeshTools.get_vertexes_by_element方法的具体用法?Python FemMeshTools.get_vertexes_by_element怎么用?Python FemMeshTools.get_vertexes_by_element使用的例子?那么恭喜您, 这里精选的方法代码示例或许可以为您提供帮助。您也可以进一步了解该方法所在FemMeshTools的用法示例。


在下文中一共展示了FemMeshTools.get_vertexes_by_element方法的2个代码示例,这些例子默认根据受欢迎程度排序。您可以为喜欢或者感觉有用的代码点赞,您的评价将有助于系统推荐出更棒的Python代码示例。

示例1: get_group_data

# 需要导入模块: import FemMeshTools [as 别名]
# 或者: from FemMeshTools import get_vertexes_by_element [as 别名]
 def get_group_data(self):
     if self.analysis:
         print('  Group meshing.')
         import FemMeshTools
         self.group_elements = FemMeshTools.get_analysis_group_elements(self.analysis, self.part_obj)
         print(self.group_elements)
     else:
         print('  NO group meshing.')
     self.ele_length_map = self.mesh_obj.CharacteristicLengthMap
     self.ele_node_map = {}
     if self.ele_length_map:
         import FemMeshTools
         print(self.ele_length_map)
         self.ele_node_map = {}
         for e in self.ele_length_map:
             if not e.startswith('Solid'):
                 # Face, Edge, Vertex
                 ele_shape = self.part_obj.Shape.getElement(e)
             else:
                 # Solid
                 ele_shape_index = int(e.lstrip('Solid')) - 1
                 ele_shape = self.part_obj.Shape.Solids[ele_shape_index]
             ele_vertexes = FemMeshTools.get_vertexes_by_element(self.part_obj.Shape, ele_shape)
             self.ele_node_map[e] = ele_vertexes
         print(self.ele_node_map)
开发者ID:eivindkv,项目名称:free-cad-code,代码行数:27,代码来源:FemGmshTools.py

示例2: get_group_data

# 需要导入模块: import FemMeshTools [as 别名]
# 或者: from FemMeshTools import get_vertexes_by_element [as 别名]
    def get_group_data(self):
        if self.analysis:
            print('  Group meshing.')
            self.group_elements = FemMeshTools.get_analysis_group_elements(self.analysis, self.part_obj)
            print('  {}'.format(self.group_elements))
        else:
            print('  NO group meshing.')

        self.ele_length_map = {}  # { 'ElementString' : element length }
        self.ele_node_map = {}  # { 'ElementString' : [element nodes] }
        if not self.mesh_obj.MeshRegionList:
            print ('  No Mesh regions.')
        else:
            print ('  Mesh regions, we need to get the elements.')
            if self.part_obj.Shape.ShapeType == 'Compound':
                # see http://forum.freecadweb.org/viewtopic.php?f=18&t=18780&start=40#p149467 and http://forum.freecadweb.org/viewtopic.php?f=18&t=18780&p=149520#p149520
                err = "GMSH could return unexpected meshes for a boolean split tools Compound. It is strongly recommended to extract the shape to mesh from the Compound and use this one."
                FreeCAD.Console.PrintError(err + "\n")
            for mr_obj in self.mesh_obj.MeshRegionList:
                # print(mr_obj.Name)
                # print(mr_obj.CharacteristicLength)
                # print(Units.Quantity(mr_obj.CharacteristicLength).Value)
                if mr_obj.CharacteristicLength:
                    if mr_obj.References:
                        for sub in mr_obj.References:
                            # print(sub[0])  # Part the elements belongs to
                            # check if the shape of the mesh region is an element of the Part to mesh, if not try to find the element in the shape to mesh
                            search_ele_in_shape_to_mesh = False
                            if not self.part_obj.Shape.isSame(sub[0].Shape):
                                # print("  One element of the meshregion " + mr_obj.Name + " is not an element of the Part to mesh.")
                                # print("  But we gone try to find it in the Shape to mesh :-)")
                                search_ele_in_shape_to_mesh = True
                            for eles in sub[1]:
                                # print(eles)  # element
                                if search_ele_in_shape_to_mesh:
                                    # we gone try to find the element it in the Shape to mesh and use the found element as eles
                                    ele_shape = FemMeshTools.get_element(sub[0], eles)  # the method getElement(element) does not return Solid elements
                                    found_element = FemMeshTools.find_element_in_shape(self.part_obj.Shape, ele_shape)
                                    if found_element:
                                        eles = found_element
                                    else:
                                        FreeCAD.Console.PrintError("One element of the meshregion " + mr_obj.Name + " could not be found in the Part to mesh. It will be ignored.\n")
                                # print(eles)  # element
                                if eles not in self.ele_length_map:
                                    self.ele_length_map[eles] = Units.Quantity(mr_obj.CharacteristicLength).Value
                                else:
                                    FreeCAD.Console.PrintError("The element " + eles + " of the meshregion " + mr_obj.Name + " has been added to another mesh region.\n")
                    else:
                        FreeCAD.Console.PrintError("The meshregion: " + mr_obj.Name + " is not used to create the mesh because the reference list is empty.\n")
                else:
                    FreeCAD.Console.PrintError("The meshregion: " + mr_obj.Name + " is not used to create the mesh because the CharacteristicLength is 0.0 mm.\n")
            for elel in self.ele_length_map:
                ele_shape = FemMeshTools.get_element(self.part_obj, elel)  # the method getElement(element) does not return Solid elements
                ele_vertexes = FemMeshTools.get_vertexes_by_element(self.part_obj.Shape, ele_shape)
                self.ele_node_map[elel] = ele_vertexes
        print('  {}'.format(self.ele_length_map))
        print('  {}'.format(self.ele_node_map))
开发者ID:abdullahtahiriyo,项目名称:FreeCAD_sf_master,代码行数:59,代码来源:FemGmshTools.py


注:本文中的FemMeshTools.get_vertexes_by_element方法示例由纯净天空整理自Github/MSDocs等开源代码及文档管理平台,相关代码片段筛选自各路编程大神贡献的开源项目,源码版权归原作者所有,传播和使用请参考对应项目的License;未经允许,请勿转载。